unit CallWndProcHook;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, BaseHook;

type
  TCallWndProcHook = class(TBaseHook)
  private
    FCWPStruct : TCWPStruct;
  protected
    procedure AssignStruct (address : Pointer); override;
    procedure FillParams (var AIdHook : Integer; var AHHookAddr : PHandle; var AInstallCountAddr : PInteger;
                          var HookProc : Pointer; var AHooksList : TList); override;
  public
    property CWPStruct : TCWPStruct read FCWPStruct;
  end;

procedure Register;

implementation

var
  CanWndProcHooks : TList;
  HHook : THandle;
  InstallCount : Integer;

function CallWndProc (nCode : integer; wParam : integer; lParam : Longint) : longint; stdcall;
begin
  Result := HookProc (HHook, CanWndProcHooks, nCode, wParam, lParam);
end;

procedure TCallWndProcHook.AssignStruct;
begin
  FCWPStruct := TCWPStruct (address^); 
end;

procedure TCallWndProcHook.FillParams;
begin
  AIdHook := WH_CALLWNDPROC;
  AHHookAddr := @HHook;
  AInstallCountAddr := @installCount;
  HookProc := @CallWndProc;
  AHooksList := CanWndProcHooks;
end;

{ Register Proc }

procedure Register;
begin
  RegisterComponents('Misc2', [TCallWndProcHook]);
end;

initialization
  InstallCount := 0;
  CanWndProcHooks := TList.Create;
finalization
  CanWndProcHooks.Free;
end.
